  
"
    _____________________________________________________________________________________

    @German Viscuso 10/04/04 <netquake@netquake.com.ar>
    This project sources are property of : German Viscuso

	Redistribution and use in source and binary forms, with or without modification,
	are not permitted without written rights.

	This software is provided by the copyright holders and contributors AS IS and
	any express or implied warranties, including, but not limited to, the implied
	warranties of merchantability and fitness for a particular purpose are disclaimed.
	In no event shall German Viscuso or contributors be liable for any direct,
	indirect, incidental, special, exemplary, or consequential damages
	(including, but not limited to, procurement of substitute goods or services;
	loss of use, data, or profits; or business interruption) however caused
	and on any theory of liability, whether in contract, strict liability,
	or tort (including negligence or otherwise) arising in any way out of
	the use of this software, even if advised of the possibility of such damage.
    _____________________________________________________________________________________
"!

Object subclass: #SmallsotObject
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

SmallsotObject subclass: #RandomNumberGenerator
  instanceVariableNames: 
    ' seed ranList i j modulus lowerBound upperBound '
  classVariableNames: ''
  poolDictionaries: ''   !

SmallsotObject subclass: #SmallsotModule
  instanceVariableNames: 
    ' id '
  classVariableNames: ''
  poolDictionaries: ''  !

SmallsotModule subclass: #MathModule
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

SmallsotModule subclass: #NavModule
  instanceVariableNames: 
    ' navigator '
  classVariableNames: ''
  poolDictionaries: ''    !

SmallsotObject subclass: #SmallsotPoint
  instanceVariableNames: 
    ' point '
  classVariableNames: ''
  poolDictionaries: ''    !

SmallsotPoint subclass: #Ball
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

SmallsotPoint subclass: #Robot
  instanceVariableNames: 
    ' number rotation '
  classVariableNames: ''
  poolDictionaries: ''   !

Robot subclass: #OpponentRobot
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

Robot subclass: #TeamRobot
  instanceVariableNames: 
    ' wheels navigation random '
  classVariableNames: ''
  poolDictionaries: ''  !

TeamRobot subclass: #BallChaser
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

TeamRobot subclass: #GoalKeeper
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

TeamRobot subclass: #RandomWalker
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

SmallsotObject subclass: #SmallsotState
  instanceVariableNames: 
    ' teamRobots opponentRobots gameState whosBall currentBall lastBall predictedBall fieldBounds goalBounds '
  classVariableNames: ''
  poolDictionaries: ''   !

DynamicLinkLibrary variableByteSubclass: #SmallsotDLL
  classVariableNames: 
    ' callback '
  poolDictionaries: ''    !

ApplicationCoordinator subclass: #SmallsotApplicationCoordinator
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

SmallsotApplicationCoordinator subclass: #SmallsotMonitor
  instanceVariableNames: 
    ' players dll running '
  classVariableNames: ''
  poolDictionaries: 
    ' ColorConstants OperatingSystemConstants ' !

CompositePane subclass: #SmallsotCompositePane
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

SmallsotCompositePane subclass: #Field2DCompositePane
  instanceVariableNames: 
    ' state '
  classVariableNames: ''
  poolDictionaries: 
    ' ColorConstants OperatingSystemConstants '   !

ExternalBuffer subclass: #SmallsotExternalBuffer
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

SmallsotExternalBuffer subclass: #SSBall
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

SmallsotExternalBuffer subclass: #SSBounds
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

SmallsotExternalBuffer subclass: #SSEnvironment
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

SmallsotExternalBuffer subclass: #SSOpponentRobot
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

SSOpponentRobot subclass: #SSRobot
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

SmallsotExternalBuffer subclass: #SSVector3D
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !


!SmallsotObject methods !

anyonesBall

	^0!
 
blueBall

	^1
!
  
dll
	" Return the DLL wrapper for the receiver's hierarchy."

	^SmallsotDLL current!
 
fBot

	^6.3730!
   
fLeft

	^6.8118





!
  
fRight

	^93.4259
!
  
fTop

	^77.2392
!

gBotY
	
	^33.9320
!
  
gLeft

	^2.8748
!

gRight

	^97.3632
!
  
gTopY

	^49.6801


!
   
maxPower
	"Max robot power constant."

	^125.0!
  
yellowBall

	^2

! !



!RandomNumberGenerator methods !

initialize
        " Private - initialize the receiver. "
    lowerBound := 0.0.
    upperBound := 1.0.
    modulus := 32767.
    self setRandomSeed.!
 
lowerBound
        "Answer the lowerBound"
    ^lowerBound!
   
lowerBound: aNumber
        "Set the lower bound of the random number range"
     lowerBound := aNumber.!
 
modulus
        " Private - Answer the modulus"
    ^modulus!
 
next
        "Generate a random number in the range of
        lowerBound to upperBound"
    | randNum answer |
    randNum := ( ( ranList at: i ) + ( ranList at: j ) ) rem: self modulus.
    randNum < 0
        ifTrue: [ randNum := randNum + self modulus ].
    ranList at: i put: randNum.
    i := i - 1.
    ( i = 0 ) ifTrue: [ i := 17 ].
    j := j  - 1.
    ( j = 0 ) ifTrue: [ j := 17 ].
    randNum := ( randNum / self modulus ) asFloat.
    answer := randNum * ( self upperBound  -  self lowerBound )
        + self lowerBound.
    ( self lowerBound isInteger and: [ self upperBound isInteger ] )
        ifTrue: [ answer  :=  answer truncated ].
    "self triggerEvent: #next: with: answer."
    ^answer!
 
seed
        "Answer the seed"
    ^seed!
 
seed: anInteger
        "Set the random number generator seed and ranList"
    |  allEven  num |
    ( anInteger isNil )
        ifTrue: [ num := seed. ]
        ifFalse: [ seed := num := anInteger asInteger ].
    ranList := Array new: 17 .
    allEven := true.
    [ allEven ]
        whileTrue: [
            1 to: 17 do: [ :k |
                num := ( ( num * 2743 ) + 5923 ) rem:  modulus.
                num < 0
                    ifTrue: [ num := num + modulus ].
                ( num / 2 ) isInteger
                    ifTrue: [ allEven := false ].
                ranList at: k put: num ] ].
    i  := 17.
    j  :=  5.!

setRandomSeed
        "Set the default random number seed"
     self seed: Time now asSeconds.!
   
setSeed: anInteger
        "Set the random number generator seed and ranList"
    self seed: anInteger.
    ^anInteger!
  
upperBound
        "Answer the upperBound"
    ^upperBound!
   
upperBound: aNumber
        "Set the upper bound of the random number range"
     upperBound := aNumber.! !



!SmallsotModule methods !
  
id
    "Returns the instance var of the receiver
     for external manipulation"
    ^id!

id: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    id := anObject!
   
isModule
	" Return whether the receiver is a module."

	^true! !



!MathModule class methods !
  
getDirectionFrom: aPoint to: otherPoint

	| angleFromZero |

	angleFromZero := (self point: aPoint bearingToPoint: otherPoint) - 90.
	(angleFromZero > 180) ifTrue: [ angleFromZero := angleFromZero - 360].

	^angleFromZero!
   
point: aPoint bearingToPoint: anotherPoint
    "Return the bearing, in degrees, from aPoint to anotherPoint.
     Adapted from Playground, where the ultimate provenance of the
	algorithm was a wild earlier method of Jay Fenton's which I never
	checked carefully, but the thing has always seemed to work."

    | deltaX deltaY  |
    deltaX := anotherPoint x -  aPoint x.
    deltaY := anotherPoint y - aPoint y.

    deltaX abs < 0.001
        ifTrue:
            [^ deltaY > 0 ifTrue: [180] ifFalse: [0]].

    ^ ((deltaX >= 0 ifTrue: [90] ifFalse: [270])
            - ((deltaY / deltaX) arcTan negated * 57.2957795131)) rounded!
  
sgn: aNumber
	" Return -1 if aNumber is negative, 1 if positive, 0 if zero."

	(aNumber = 0) ifTrue: [^0].
	(aNumber < 0) ifTrue: [^-1].
	(aNumber > 0) ifTrue: [^1].

	self error: 'Error in sgn!!'! !



!NavModule class methods !

for: aNavigator
	" Create an instance of the receiver for aNavigator"

	^self new navigator: aNavigator! !



!NavModule methods !
   
gotoPoint: aPoint
	" Make navigator reach aPoint with maximun acceleration."

	^self gotoPoint: aPoint withAcceleration: self maxPower
	!
   
gotoPoint: aPoint withAcceleration: aNumber
	" Make navigator reach aPoint with maximun acceleration equal to aNumber."

	| delta t r pointDirection navigatorRotation |

	pointDirection := MathModule getDirectionFrom: navigator to: aPoint.
	navigatorRotation := self navigator rotation.

	delta := ( pointDirection - navigatorRotation ) degreesToRadians.

	t := delta cos squared * delta cos sign.
	r := delta sin squared * delta sin sign.

	navigator left: aNumber * ( t - r ).
	navigator right: aNumber * ( t + r )!
 
gotoPointSmooth: aPoint
	" Make navigator reach aPoint with maximun acceleration."

	^self gotoPointSmooth: aPoint withAcceleration: self maxPower
	!
   
gotoPointSmooth: aPoint withAcceleration: aNumber
	" Make navigator reach aPoint with maximun acceleration equal to aNumber."

	| delta t r pointDirection navigatorRotation powerDifference |

	pointDirection := MathModule getDirectionFrom: navigator to: aPoint.
	navigatorRotation := self navigator rotation.

	delta := ( pointDirection - navigatorRotation ) degreesToRadians.

	t := delta cos squared * delta cos sign.
	r := delta sin squared * delta sin sign.

	powerDifference := self mapPowerDifference: self navigator.

	navigator left: aNumber * ( t - r ) * powerDifference.
	navigator right: aNumber * ( t + r ) * powerDifference!
   
mapPowerDifference: aTeamRobot
	" Maps wheel power difference to a value in interval [0,1].
	Used for robot movement smoothing."

	| powerRange difference inverseMap |

	powerRange := 2 * self maxPower.
	difference := 0.0.

	( aTeamRobot left sign = aTeamRobot right sign )
		ifTrue: [ difference := ( aTeamRobot left abs - aTeamRobot right abs ) abs ]
		ifFalse: [
			( aTeamRobot left >= 0 )
				ifTrue: [ difference := aTeamRobot left + aTeamRobot right abs ]
				ifFalse: [ difference := aTeamRobot right + aTeamRobot left abs ] ].

	inverseMap := ( 1 / powerRange ) * difference.

	( inverseMap > 0.85 )
		ifTrue: [ ^0.15 ]
		ifFalse: [ ^1 - inverseMap ]

"	double maxPower = MAXVEL;
	double powerRange = 2*maxPower;

	double dif = 0.0;

	if(sgn(robot.velocityLeft)==sgn(robot.velocityRight)){
		dif = module(module(robot.velocityLeft)-module(robot.velocityRight));
	}
	else{
		if(robot.velocityLeft>=0){
			dif = robot.velocityLeft + module(robot.velocityRight);
		}
		else{
			dif = robot.velocityRight + module(robot.velocityLeft);
		}
	}
	
	double inverseMap = (1/powerRange)*dif;

	if(inverseMap > 0.85)
		return 0.15;
	else
		return 1-inverseMap;"!
 
navigator
    "Returns the instance var of the receiver
     for external manipulation"
    ^navigator!
  
navigator: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    navigator := anObject! !



!SmallsotPoint class methods !
 
fromPoint: aPoint
	" Initialize the receiver from aPoint."

	^self x: aPoint x y: aPoint y!
  
x: aNumber y: otherNumber
	" Return an instance of the receiver given x and y values."

	^self new x: aNumber y: otherNumber! !



!SmallsotPoint methods !
  
initializePoint
	" Private - Initializes the receiver's point"

	point := 0 @ 0!
 
point
    "Returns the instance var of the receiver
     for external manipulation"

	point isNil ifTrue: [ self initializePoint ].
    ^point!

point: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    point := anObject!
 
printOn: aStream
	" Print a string representation of the receiver on aStream."

	aStream 
		nextPutAll: self x printString;
		nextPutAll: '@';
		nextPutAll: self y printString;
		yourself!
 
x
	" Return x value for the receiver."

	^self point x!
  
x: aNumber
	" Set x value for the receiver."

	self point x: aNumber!

x: aNumber y: otherNumber
	" Set x and y values for the receiver."

	self point x: aNumber.
	self point y: otherNumber!
 
y
	" Return y value for the receiver."

	^self point y!
  
y: aNumber
	" Set y value for the receiver."

	self point y: aNumber! !



!Ball class methods !
 
fromStruct: anSSBall
	"Fill the receiver from simulation struct."

	| instance |
	instance := self new.
	instance 
		x: anSSBall pos x
		y: anSSBall pos y.
	^instance! !



!Robot class methods !
 
new: aNumber
	"	Return an instance of the receiver and set aNumber."
	
	^self new number: aNumber! !



!Robot methods !
 
number
    "Returns the instance var of the receiver
     for external manipulation"
    ^number!

number: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    number := anObject!
   
position
    " Returns current cartesian position of the receiver."

    ^self point!

position: aPoint
    " Set the current cartesian position for the receiver."
    
	self point: ( SmallsotPoint fromPoint: aPoint )!
  
rotation
    "Returns the instance var of the receiver
     for external manipulation"
    ^rotation!

rotation: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    rotation := anObject! !



!OpponentRobot class methods !
   
fromStruct: anSSOpponentRobot
	"Fill the receiver from simulation struct."

	| instance |
	instance := self new.
	instance 
		x: anSSOpponentRobot pos x
		y: anSSOpponentRobot pos y.
	instance rotation: anSSOpponentRobot rotation.
	^instance! !



!TeamRobot class methods !
 
fromStruct: anSSRobot
	"Fill the receiver from simulation struct."

	| instance |
	instance := self new.
	instance 
		x: anSSRobot pos x
		y: anSSRobot pos y.
	instance rotation: anSSRobot rotation.
	instance left: anSSRobot velocityLeft.
	instance right: anSSRobot velocityLeft.
	^instance!
  
navigationSupport
	" Return support class for navigation."

	^NavModule! !



!TeamRobot methods !
   
calculateWheels
	"Calculate next power values for the receiver's wheels"

		^self implementedBySubclass
	
	!
   
commit
	" Commit the receiver to the simulation."

	self calculateWheels.
	self commitWheels
	
	!
 
commitWheels
	" Commit wheels power value for the receiver to the simulator."

	self dll teamRobotWheels: self number value: self wheels!

externalChanged: anInteger
	" The external environment has changed (callback)."

	self 
		update;
		commit;
		yourself!
   
initialize
	" Initialize the receiver."

	"timer := Timer new.
	timer period: 100.
	timer when: #ticked send: #commit to: self.
	timer start"!

initializeNavigation
	" Private - Initializes the receiver's navigation"

	navigation := self class navigationSupport for: self!
 
initializeRandom
	" Private - Initializes the receiver's random"

	random := RandomNumberGenerator new.
	random initialize.
	random lowerBound: -125.0.
	random upperBound: 125.0
!
  
initializeWheels
	" Private - Initializes the receiver's wheels"

	wheels := SmallsotPoint fromPoint: 0.0 @ 0.0!
 
left
	" Return left wheel power value for the receiver."

	^wheels x!

left: aFloat
	" Set left wheel power value for the receiver."

	self wheels x: aFloat!
   
navigation
    "Returns the instance var of the receiver
     for external manipulation"

	navigation isNil ifTrue: [ self initializeNavigation ].
    ^navigation!

navigation: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    navigation := anObject!
   
random
    "Returns the instance var of the receiver
     for external manipulation"

	random isNil ifTrue: [ self initializeRandom ].
    ^random!

random: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    random := anObject!
   
right
	" Return right wheel power value for the receiver."

	^wheels y!
  
right: aFloat
	" set right wheel power value for the receiver."

	self wheels y: aFloat!
 
stop
	" Stop the receiver."

	self left: 0.0.
	self right: 0.0.!

update
	" Update the receiver from the simulation."

	self
		updateWheels;
		updatePosition;
		updateRotation;
		yourself
	!

updatePosition
	" Update position of the receiver from the simulator."

	| aPoint |
	aPoint := self dll teamRobotPosition: self number.
	self position: aPoint!

updateRotation
	" Update rotation of the receiver from the simulator."
	
	self rotation: ( self dll teamRobotRotation: self number )!

updateWheels
	" Update wheels power value for the receiver from the simulator."
	
	| aPoint |
	aPoint := self dll teamRobotWheels: self number.
	self wheels: aPoint!
  
wheels
    "Returns the instance var of the receiver
     for external manipulation"

	wheels isNil ifTrue: [ self initializeWheels ].
    ^wheels!

wheels: aPoint
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    wheels := ( SmallsotPoint fromPoint: aPoint )! !



!BallChaser methods !
 
calculateWheels
	"Calculate next power values for the receiver's wheels"

	self navigation gotoPointSmooth: ( self dll currentBall )! !



!GoalKeeper methods !
 
calculateWheels
	"Calculate next power values for the receiver's wheels"

	| currentBall ballY robotRotation atenuation |

	( ( self x < 89.5 ) or: [ self x > 92.5 ] )
		ifTrue: [
			^self navigation gotoPointSmooth: ( SmallsotPoint x: 89.7 y: 41.59 ) ]. "90.5 92.5 90.0"

	atenuation := 0.5.
	currentBall := self dll currentBall.
	ballY := currentBall y.
	robotRotation := self rotation.

	[ rotation > 180 ] whileTrue: [ rotation := rotation - 360 ].
	[ rotation < -180 ] whileTrue: [ rotation := rotation + 360 ].

	( ( ( rotation abs - 90 ) abs ) < 5 )
		ifTrue: [
			((self y - ballY) abs < 1)
				ifTrue: [
					self left: 0.0.
					self right: 0.0 ]
				ifFalse: [
					(self y < ballY)
					  ifTrue: [
						(self y > self gTopY)
						  ifTrue: [
							self left: 0.0.
							self right: 0.0 ]
						  ifFalse: [
							(rotation > 0)
							  ifTrue: [
								self left: self maxPower.
								self right: self maxPower ]
							  ifFalse: [
								self left: self maxPower negated.
								self right: self maxPower negated ] ] ]
					  ifFalse: [
						(self y < self gBotY)
						  ifTrue: [
							self left: 0.0.
							self right: 0.0 ]
						  ifFalse: [
							(rotation > 0)
							  ifTrue: [
								self left: self maxPower negated.
								self right: self maxPower negated ]
							  ifFalse: [
								self left: self maxPower.
								self right: self maxPower ] ] ] ] ]
			  ifFalse: [
				( rotation > 0 )
					ifTrue: [
						self left: ( 90 - rotation ) negated * atenuation.
						self right: ( 90 - rotation ) * atenuation ]
					ifFalse: [
						self left: ( rotation + 90 ) * atenuation.
						self right: ( rotation + 90 ) negated * atenuation ] ]
! !



!RandomWalker methods !

calculateWheels
	"Calculate next power values for the receiver's wheels"

	self left: self random next.
	self right: self random next! !



!SmallsotState class methods !
  
fromStruct: anSSEnvironment
	"Fill the receiver from simulation struct."

	^self new updateWith: anSSEnvironment! !



!SmallsotState methods !
  
currentBall
    "Returns the instance var of the receiver
     for external manipulation"
    ^currentBall!
  
currentBall: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    currentBall := anObject!
 
gameState
    "Returns the instance var of the receiver
     for external manipulation"
    ^gameState!
  
gameState: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    gameState := anObject!
 
initializeOpponentRobots
	" Private - Initializes the receiver's opponentRobots"

	opponentRobots := OrderedCollection new!
  
initializeTeamRobots
	" Private - Initializes the receiver's teamRobots"

	teamRobots := OrderedCollection new!
  
lastBall
    "Returns the instance var of the receiver
     for external manipulation"
    ^lastBall!

lastBall: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lastBall := anObject!
   
opponentRobots
    "Returns the instance var of the receiver
     for external manipulation"

	opponentRobots isNil ifTrue: [ self initializeOpponentRobots ].
    ^opponentRobots!

opponentRobots: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    opponentRobots := anObject!
   
predictedBall
    "Returns the instance var of the receiver
     for external manipulation"
    ^predictedBall!
  
predictedBall: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    predictedBall := anObject!
 
teamRobots
    "Returns the instance var of the receiver
     for external manipulation"

	teamRobots isNil ifTrue: [ self initializeTeamRobots ].
    ^teamRobots!

teamRobots: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    teamRobots := anObject!
   
update
	"Update the receiver from simulation."

	self gameState: self dll gameState.
	self  currentBall: self dll currentBall.
	self  lastBall: self dll lastBall.
	self  teamRobots: self dll teamRobots.
	self  opponentRobots: self dll opponentRobots!
   
updateWith: anSSEnvironment
	"Update the receiver from simulation with anSSEnvironment struct."

	| teamRobs oppRobs |

	teamRobs := OrderedCollection new.
	oppRobs := OrderedCollection new.
	self
		currentBall: ( Ball fromStruct: anSSEnvironment currentBall );
		lastBall: ( Ball fromStruct: anSSEnvironment lastBall );
		predictedBall: ( Ball fromStruct: anSSEnvironment predictedBall );
		gameState: anSSEnvironment gameState;
		whosBall: anSSEnvironment whosBall;
		yourself.
	1 to: 5 do: [:index| 
		teamRobs add: ( TeamRobot fromStruct: ( anSSEnvironment home: index )).
		oppRobs add: ( OpponentRobot fromStruct: ( anSSEnvironment opponent: index ))].
	self 
		opponentRobots: oppRobs;
		teamRobots: teamRobs;
		yourself.
!
 
whosBall
    "Returns the instance var of the receiver
     for external manipulation"
    ^whosBall!

whosBall: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    whosBall := anObject! !



!SmallsotDLL class methods !
 
callbackTable
	" Private - Returns the callback shape table for defining callback handlers."

	^#(
	"(callBackName (arguments...) returnType callingConvention)"

	( CbFuncPtr ( ulong ) none c )

	)!
  
fileName
        "Answer the receiver's file name."
    ^'C:\strategy\blue\smallsot.dll'!
 
newCallBack: callBackName sending: selector to: aReceiver
	"Returns a CallBack object for sending message with selector to aReceiver.
	callBackName must be a valid name defined in callbackTable."

	| tuple aMessage parameterTypes |
	tuple := self callbackTable
		detect: [:one| one first = callBackName ]
		ifNone: [ ^self error: 'Invalid callback name.'].

	"check selector arguments with parameterTypes size"
	parameterTypes := tuple at: 2.
	(selector asString select: [:c| c = $: ]) size = parameterTypes size
	ifFalse: [ ^self error: 'Invalid selector (Must have ',parameterTypes size asString,' arguments.' ].

	aMessage := Message new
		receiver: aReceiver;
		selector: selector;
		yourself.
	^CallBack
		registerMessage: aMessage
		parameterTypes: parameterTypes
		returnType: (tuple at: 3)
		callingConvention: (tuple size > 3 ifTrue: [ tuple at: 4 ] ifFalse: [#api]).! !



!SmallsotDLL methods !
 
activateCallback
	" Activate the callback loop."

	^self apiActivateCallbackFunction!

apiActivateCallbackFunction
	" Activate the callback function."

	<api: ActivateCallbackFunction none>
     ^self invalidArgument!
  
apiDisableCallbackFacility
	" Disable the callback facility."

	<api: DisableCallbackFacility none>
     ^self invalidArgument!
 
apiEnableCallbackFacility
	" Enable the callback facility."

	<api: EnableCallbackFacility none>
     ^self invalidArgument!

apiGetCallbackFunction
	" Get the address for the callback function."

	<api: GetCallbackFunction ulong>
     ^self invalidArgument!

apiGetCurrentBallX
	" Return current ball x axis."

	<api: GetCurrentBallX double>
     ^self invalidArgument!
  
apiGetCurrentBallY
	" Return current ball y axis."

	<api: GetCurrentBallY double>
     ^self invalidArgument!
  
apiGetEnvironment
	" Get the address for the Environment structure."

	<api: GetEnvironment ulong>
     ^self invalidArgument!
  
apiGetFieldBoundsBottom
	" Return field bounds bottom coordinate."

	<api: GetFieldBoundsBottom long>
     ^self invalidArgument!
   
apiGetFieldBoundsLeft
	" Return field bounds left coordinate."

	<api: GetFieldBoundsLeft long>
     ^self invalidArgument!
 
apiGetFieldBoundsRight
	" Return field bounds right coordinate."

	<api: GetFieldBoundsRight long>
     ^self invalidArgument!
  
apiGetFieldBoundsTop
	" Return field bounds top coordinate."

	<api: GetFieldBoundsTop long>
     ^self invalidArgument!

apiGetGameState
	" Return the game state."

	<api: GetGameState long>
     ^self invalidArgument!
   
apiGetGoalBoundsBottom
	" Return goal bounds bottom coordinate."

	<api: GetGoalBoundsBottom long>
     ^self invalidArgument!
  
apiGetGoalBoundsLeft
	" Return goal bounds left coordinate."

	<api: GetGoalBoundsLeft long>
     ^self invalidArgument!

apiGetGoalBoundsRight
	" Return goal bounds right coordinate."

	<api: GetGoalBoundsRight long>
     ^self invalidArgument!
 
apiGetGoalBoundsTop
	" Return goal bounds top coordinate."

	<api: GetGoalBoundsTop long>
     ^self invalidArgument!
   
apiGetLastBallX
	" Return last ball x axis."

	<api: GetLastBallX double>
     ^self invalidArgument!
   
apiGetLastBallY
	" Return last ball y axis."

	<api: GetLastBallY double>
     ^self invalidArgument!
   
apiGetLost
	" Return the count of lost environments."

	<api: GetLost long>
     ^self invalidArgument!
 
apiGetModified
	" Return the modified environment state."

	<api: GetModified long>
     ^self invalidArgument!
 
apiGetOpponentRobotRotation: anInteger
	" Return opponent robot anInteger rotation angle."

	<api: GetOpponentRobotRotation long double>
     ^self invalidArgument!

apiGetOpponentRobotX: anInteger
	" Return oppponent robot anInteger x axis."

	<api: GetOpponentRobotX long double>
     ^self invalidArgument!
 
apiGetOpponentRobotY: anInteger
	" Return ppponent robot anInteger y axis."

	<api: GetOpponentRobotY long double>
     ^self invalidArgument!
  
apiGetPredictedBallX
	" Return predicted ball x axis."

	<api: GetPredictedBallX double>
     ^self invalidArgument!

apiGetPredictedBallY
	" Return predicted ball y axis."

	<api: GetPredictedBallY double>
     ^self invalidArgument!

apiGetTeamRobotLeft: anInteger
	" Return team robot anInteger left wheel."

	<api: GetTeamRobotLeft long double>
     ^self invalidArgument!

apiGetTeamRobotRight: anInteger
	" Return team robot anInteger right wheel."

	<api: GetTeamRobotRight long double>
     ^self invalidArgument!
 
apiGetTeamRobotRotation: anInteger
	" Return team robot anInteger rotation angle."

	<api: GetTeamRobotRotation long double>
     ^self invalidArgument!

apiGetTeamRobotX: anInteger
	" Return team robot anInteger x axis."

	<api: GetTeamRobotX long double>
     ^self invalidArgument!
  
apiGetTeamRobotY: anInteger
	" Return team robot anInteger y axis."

	<api: GetTeamRobotY long double>
     ^self invalidArgument!
  
apiGetWhosBall
	" Return who owns the ball."

	<api: GetWhosBall long>
     ^self invalidArgument!
  
apiResetLost
	" Reset the count of lost environments."

	<api: ResetLost none>
     ^self invalidArgument!
  
apiSetCallbackFunction: pCallback
	" Set the callback function to pCallback."

	<api: SetCallbackFunction ulong none>
     ^self invalidArgument!
   
apiSetModified
	" Set the modified environment state."

	<api: SetModified none>
     ^self invalidArgument!

apiSetPredictedBallX: aFloat
	" Set predicted ball x axis."

	<api: SetPredictedBallX double none>
     ^self invalidArgument!
  
apiSetPredictedBallY: aFloat
	" Set predicted ball y axis."

	<api: SetPredictedBallY double none>
     ^self invalidArgument!
  
apiSetTeamRobotLeft: anInteger value: aFloat
	" Set team robot anInteger left wheel with value aFloat."

	<api: SetTeamRobotLeft long double none>
     ^self invalidArgument!
  
apiSetTeamRobotRight: anInteger value: aFloat
	" Set team robot anInteger right wheel with value aFloat."

	<api: SetTeamRobotRight long double none>
     ^self invalidArgument!
   
callback

	^callback!
 
callback: aCallBack

	callback := aCallBack!
  
callbackTo: anObject sending: aSelector
	" Sets the callback of the receiver to send message with aSelector to anObject.
	aSelector must be a message selector with no arguments."

	self callback: ( self class
		newCallBack: #CbFuncPtr
		sending: aSelector
		to: anObject )!

currentBall
	" Return current ball position."

	^ self apiGetCurrentBallX @ self apiGetCurrentBallY!
 
disableCallbacks
	" Disable the callback facility."

	self apiDisableCallbackFacility!
   
enableCallbacks
	" Enable the callback facility."

	self apiEnableCallbackFacility!
  
environment
	"Return an SSEnvironment struct from simulation current state.
	Requires one api call only."

	^SmallsotState fromStruct: ( SSEnvironment fromAddress: ( self apiGetEnvironment asExternalAddress ) )!
 
externalChanged: anInteger
	" The external environment has changed."

	self broadcast: #externalChanged: with: anInteger!

fieldBounds: aSymbol
	" Return the field bounds according to a symbol."

	( aSymbol = #left ) ifTrue: [ ^self apiGetFieldBoundsLeft ].
	( aSymbol = #right ) ifTrue: [ ^self apiGetFieldBoundsRight ].
	( aSymbol = #top ) ifTrue: [ ^self apiGetFieldBoundsTop ].
	( aSymbol = #bottom ) ifTrue: [ ^self apiGetFieldBoundsBottom ].

	self error: 'Symbol not understood.'!

gameState
	" Return the game state." "TRANSLATE TO SYMBOLS"

     ^self apiGetGameState!
 
goalBounds: aSymbol
	" Return the goal bounds according to a symbol."

	( aSymbol = #left ) ifTrue: [ ^self apiGetGoalBoundsLeft ].
	( aSymbol = #right ) ifTrue: [ ^self apiGetGoalBoundsRight ].
	( aSymbol = #top ) ifTrue: [ ^self apiGetGoalBoundsTop ].
	( aSymbol = #bottom ) ifTrue: [ ^self apiGetGoalBoundsBottom ].

	self error: 'Symbol not understood.'!
  
initializeCallback
	" Initialize the callback for alerting the receiver."

	self callbackTo: self sending: #externalChanged:.
	self apiSetCallbackFunction: self callback asParameter!
  
lastBall
	" Return last ball position."

	^ self apiGetLastBallX @ self apiGetLastBallY!
 
lost
	" Return the count of lost environments."

	^self apiGetLost!
  
modified
	" Return whether the environment has been modified."

	^self apiGetModified
!
 
opponentRobot: anInteger
	"Return opponent robot anInteger from simulation."
	
	| opponentRobot |
	opponentRobot := OpponentRobot new: anInteger.
	opponentRobot position: ( self opponentRobotPosition: anInteger ).
	opponentRobot rotation: ( self opponentRobotRotation: anInteger ).
	^opponentRobot!
   
opponentRobotPosition: anInteger
	" Return current position of opponent player anInteger ( 1 based index )."

	^( self apiGetOpponentRobotX: anInteger - 1 ) @ ( self apiGetOpponentRobotY: anInteger - 1 )!
 
opponentRobotRotation: anInteger
	" Return current rotation of opponent player anInteger ( 1 based index )."

	^self apiGetOpponentRobotRotation: anInteger - 1!
 
opponentRobots
	"Return opponent robots from simulation."
	
	| robots |
	robots := OrderedCollection new.
	1 to: 5 do: [ :index |  robots add: ( self opponentRobot: index) ].
	^robots
	!
   
predictedBall
	" Return predicted ball position."

	^ self apiGetPredictedBallX @ self apiGetPredictedBallY!
 
predictedBall: aPoint
	" Set predicted ball position."

	self apiSetPredictedBallX: aPoint x.
	self apiSetPredictedBallY: aPoint y.!

releaseCallback
	" Release the callback of the receiver."

	self callback release!
   
resetLost
	" Reset the count of lost environments."

	^self apiResetLost!

setModified
	" Set the modified environment state."

     ^self apiSetModified!
  
teamRobot: anInteger
	"Return team robot anInteger from simulation."
	
	| teamRobot |
	teamRobot := TeamRobot new: anInteger.
	teamRobot position: ( self teamRobotPosition: anInteger ).
	teamRobot rotation: ( self teamRobotRotation: anInteger ).
	teamRobot wheels: ( self teamRobotWheels: anInteger ).
	^teamRobot!
  
teamRobotPosition: anInteger
	" Return current position of team player anInteger ( 1 based index )."

	^( self apiGetTeamRobotX: anInteger - 1 ) @ ( self apiGetTeamRobotY: anInteger - 1 )!
 
teamRobotRotation: anInteger
	" Return current rotation of team player anInteger ( 1 based index )."

	^self apiGetTeamRobotRotation: anInteger - 1!
 
teamRobots
	"Return team robots from simulation."
	
	| robots |
	robots := OrderedCollection new.
	1 to: 5 do: [ :index |  robots add: ( self teamRobot: index) ].
	^robots
	!
   
teamRobotWheels: anInteger
	" Return current wheels of team player anInteger ( 1 based index )."

	^( self apiGetTeamRobotLeft: anInteger - 1 ) @ ( self apiGetTeamRobotRight: anInteger - 1 )!
  
teamRobotWheels: anInteger value: aPoint
	" Set current wheels of team player anInteger ( 1 based index ) with aPoint."

	self apiSetTeamRobotLeft: anInteger - 1 value: aPoint x.
	self apiSetTeamRobotRight: anInteger - 1 value: aPoint y! !



!SmallsotMonitor class methods !
 
buildView: aView forModel: aModel

	"WARNING!! This method was automatically generated by 
	WindowBuilder. Code you add here which does not conform to 
	the WindowBuilder API will probably be lost the next time 
	you save your layout definition."

	| buttonInspect buttonLoop buttonStopLoop checkBoxDisplay 
	comboRobot1 comboRobot2 comboRobot3 comboRobot4 comboRobot5 
	field2d staticText1 staticText2 staticText3 staticText4 
	staticText5 statusBar xDU yDU |
	#generated.
	xDU := (SysFont width + 1 roundTo: 2) / 4.
	yDU := SysFont height / 8.
	
		"Temporary Variables"
	buttonInspect := Button new.
	buttonLoop := Button new.
	buttonStopLoop := Button new.
	checkBoxDisplay := CheckBox new.
	comboRobot1 := WBComboBox new.
	comboRobot2 := WBComboBox new.
	comboRobot3 := WBComboBox new.
	comboRobot4 := WBComboBox new.
	comboRobot5 := WBComboBox new.
	field2d := Field2DCompositePane new.
	staticText1 := StaticText new.
	staticText2 := StaticText new.
	staticText3 := StaticText new.
	staticText4 := StaticText new.
	staticText5 := StaticText new.
	statusBar := StatusPane new.
	
	aView
		owner: aModel;
		setName: 'mainView';
		labelWithoutPrefix: 'Smallsot Monitor';
		noSmalltalkMenuBar;
		backColor: Color gray;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 1/2; leftInset: -183 * xDU;
				topRatio: 1/2; topInset: -128 * yDU;
				rightRatio: 1/2; rightInset: -183 * xDU;
				bottomRatio: 1/2; bottomInset: -128 * yDU).
	
	statusBar "StatusPane"
		owner: aModel;
		setName: 'statusBar';
		framingBlock: 
			(LayoutFrame new
				leftRatio: 0; leftInset: 0 * xDU;
				topRatio: 1; topInset: -12 * yDU;
				rightRatio: 1; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 0 * yDU);
		contents: (
			OrderedCollection new
				addLast: (
					StatusBox new
					    space: 7;
					    width: 10;
					    name: #notifier
				);
				yourself
		);
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: statusBar.
	
	buttonLoop
		owner: aModel;
		setName: 'buttonLoop';
		when: #clicked send: #buttonLoopClicked to: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 61/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -35 * yDU;
				rightRatio: 75/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 19 * yDU);
		contents: 'Start';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: buttonLoop.
	
	buttonStopLoop
		owner: aModel;
		setName: 'buttonStopLoop';
		when: #clicked send: #buttonStopLoopClicked to: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 78/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -35 * yDU;
				rightRatio: 92/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 19 * yDU);
		contents: 'Stop';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: buttonStopLoop.
	
	buttonInspect
		owner: aModel;
		setName: 'buttonInspect';
		when: #clicked send: #buttonInspectClicked to: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 95/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -35 * yDU;
				rightRatio: 113/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 19 * yDU);
		contents: 'Inspect';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: buttonInspect.
	
	comboRobot1 "WBComboBox"
		owner: aModel;
		setName: 'comboRobot1';
		when: #changed: send: #combo1Changed: to: aModel;
		when: #needsContents send: #combo1NeedsContents: to: aModel with: comboRobot1;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 24/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -163 * yDU;
				rightRatio: 59/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 113 * yDU);
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: comboRobot1.
	
	comboRobot2 "WBComboBox"
		owner: aModel;
		setName: 'comboRobot2';
		addClipsiblingsStyle;
		when: #changed: send: #combo2Changed: to: aModel;
		when: #needsContents send: #combo2NeedsContents: to: aModel with: comboRobot2;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 24/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -147 * yDU;
				rightRatio: 59/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 97 * yDU);
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: comboRobot2.
	
	comboRobot3 "WBComboBox"
		owner: aModel;
		setName: 'comboRobot3';
		addClipsiblingsStyle;
		when: #changed: send: #combo3Changed: to: aModel;
		when: #needsContents send: #combo3NeedsContents: to: aModel with: comboRobot3;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 24/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -131 * yDU;
				rightRatio: 59/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 81 * yDU);
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: comboRobot3.
	
	comboRobot4 "WBComboBox"
		owner: aModel;
		setName: 'comboRobot4';
		addClipsiblingsStyle;
		when: #changed: send: #combo4Changed: to: aModel;
		when: #needsContents send: #combo4NeedsContents: to: aModel with: comboRobot4;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 24/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -115 * yDU;
				rightRatio: 59/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 65 * yDU);
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: comboRobot4.
	
	comboRobot5 "WBComboBox"
		owner: aModel;
		setName: 'comboRobot5';
		addClipsiblingsStyle;
		when: #changed: send: #combo5Changed: to: aModel;
		when: #needsContents send: #combo5NeedsContents: to: aModel with: comboRobot5;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 24/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -99 * yDU;
				rightRatio: 59/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 49 * yDU);
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: comboRobot5.
	
	staticText1
		owner: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 6/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -161 * yDU;
				rightRatio: 21/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 153 * yDU);
		contents: 'Robot 1';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: staticText1.
	
	staticText2
		owner: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 6/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -145 * yDU;
				rightRatio: 21/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 137 * yDU);
		contents: 'Robot 2';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: staticText2.
	
	staticText3
		owner: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 6/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -129 * yDU;
				rightRatio: 21/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 121 * yDU);
		contents: 'Robot 3';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: staticText3.
	
	staticText4
		owner: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 6/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -113 * yDU;
				rightRatio: 21/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 105 * yDU);
		contents: 'Robot 4';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: staticText4.
	
	staticText5
		owner: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 6/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -97 * yDU;
				rightRatio: 21/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 89 * yDU);
		contents: 'Robot 5';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: staticText5.
	
	field2d "Field2DCompositePane"
		owner: aModel;
		setName: 'field2d';
		framingBlock: 
			(LayoutFrame new
				leftRatio: 1; leftInset: -232 * xDU;
				topRatio: 1; topInset: -223 * yDU;
				rightRatio: 1; rightInset: 8 * xDU;
				bottomRatio: 1; bottomInset: 41 * yDU);
		startGroup;
		noTabStop.
	aView addSubpane: field2d.
	
	checkBoxDisplay
		owner: aModel;
		setName: 'checkBoxDisplay';
		addClipsiblingsStyle;
		when: #checked send: #checkBoxDisplayChecked to: aModel;
		when: #needsContents send: #checkBoxDisplayNeedsContents: to: aModel with: checkBoxDisplay;
		when: #unchecked send: #checkBoxDisplayUnchecked to: aModel;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 19/181; leftInset: 0 * xDU;
				topRatio: 1; topInset: -67 * yDU;
				rightRatio: 48/181; rightInset: 0 * xDU;
				bottomRatio: 1; bottomInset: 57 * yDU);
		contents: 'Display Viewer';
		startGroup;
		noTabStop;
		font: SysFont.
	aView addSubpane: checkBoxDisplay!

wbBasicVersion

	"Private - Answer the WindowBuilder Pro version.
		Generated in: Visual Smalltalk 3.1.1 Win32"

	^3.11! !



!SmallsotMonitor methods !
   
basePlayerSupport
	" Returns the base class for robot players."

	^TeamRobot!

buttonInspectClicked

	"Callback for the #clicked event in buttonInspect [Button].
		(Generated by WindowBuilder Pro)"

	self inspect
!
   
buttonLoopClicked

	"Callback for the #clicked event in buttonLoop [Button].
		(Generated by WindowBuilder Pro)"

	running := true.
	[
		[ running ] whileTrue: [ self updatePlayers. self field2d updateWith: self environment ]
	] forkAt: 3
!
   
buttonStopLoopClicked

	"Callback for the #clicked event in buttonStopLoop [Button].
		(Generated by WindowBuilder Pro)"

	running := false
!
 
checkBoxDisplayChecked

	"Callback for the #checked event in checkBoxDisplay [CheckBox].
		(Generated by WindowBuilder Pro)"

	self field2d showWindow
!
  
checkBoxDisplayNeedsContents: aPane

	"Callback for the #needsContents event in checkBoxDisplay [CheckBox].
		(Generated by WindowBuilder Pro)"

	( self paneNamed: 'checkBoxDisplay' ) check
!
   
checkBoxDisplayUnchecked

	"Callback for the #unchecked event in checkBoxDisplay [CheckBox].
		(Generated by WindowBuilder Pro)"

	self field2d hideWindow!

combo1

	^self paneNamed: 'comboRobot1'!
  
combo1Changed: selectedItem

	"Callback for the #changed: event in comboRobot1 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	self initializePlayer1!
 
combo1NeedsContents: aPane

	"Callback for the #needsContents event in comboRobot1 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	aPane
		contents: self basePlayerSupport subclasses;
		selectItem: 2;
		yourself
	!
 
combo2

	^self paneNamed: 'comboRobot2'!
  
combo2Changed: selectedItem

	"Callback for the #changed: event in comboRobot2 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	self initializePlayer2!
 
combo2NeedsContents: aPane

	"Callback for the #needsContents event in comboRobot2 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	aPane
		contents: self basePlayerSupport subclasses;
		selectItem: 1;
		yourself!

combo3

	^self paneNamed: 'comboRobot3'!
  
combo3Changed: selectedItem

	"Callback for the #changed: event in comboRobot3 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	self initializePlayer3!
 
combo3NeedsContents: aPane

	"Callback for the #needsContents event in comboRobot3 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	aPane
		contents: self basePlayerSupport subclasses;
		selectItem: 1;
		yourself
!
  
combo4

	^self paneNamed: 'comboRobot4'!
  
combo4Changed: selectedItem

	"Callback for the #changed: event in comboRobot4 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	self initializePlayer4!
 
combo4NeedsContents: aPane

	"Callback for the #needsContents event in comboRobot4 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	aPane
		contents: self basePlayerSupport subclasses;
		selectItem: 1;
		yourself!

combo5

	^self paneNamed: 'comboRobot5'!
  
combo5Changed: selectedItem

	"Callback for the #changed: event in comboRobot5 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	self initializePlayer5!
 
combo5NeedsContents: aPane

	"Callback for the #needsContents event in comboRobot5 [WBComboBox].
		(Generated by WindowBuilder Pro)"

	aPane
		contents: self basePlayerSupport subclasses;
		selectItem: 1;
		yourself!

dll
    "Returns the instance var of the receiver
     for external manipulation"

	dll isNil ifTrue: [ self initializeDll ].
    ^dll!

dll: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    dll := anObject!
 
environment
	"Return full game environment in a SmallsotState instance."

	^self dll environment
	!
 
field2d
	"Returns the field2d of the receiver's view."

	^self paneNamed: 'field2d'!
 
initializeDll
	" Private - Initializes the receiver's dll"

	dll := SmallsotDLL current!
 
initializePlayer1
	" Private - Initializes the receiver's player1"

	self playerAt: 1 put: ( ( self combo1 selectedItem ) new: 1 ).
	( self playerAt: 1 ) initialize
!
 
initializePlayer2
	" Private - Initializes the receiver's player2"

	self playerAt: 2 put: ( ( self combo2 selectedItem ) new: 2 ).
	( self playerAt: 2 ) initialize!
   
initializePlayer3
	" Private - Initializes the receiver's player3"

	self playerAt: 3 put: ( ( self combo3 selectedItem ) new: 3 ).
	( self playerAt: 3 ) initialize!
   
initializePlayer4
	" Private - Initializes the receiver's player4"

	self playerAt: 4 put: ( ( self combo4 selectedItem ) new: 4 ).
	( self playerAt: 4 ) initialize!
   
initializePlayer5
	" Private - Initializes the receiver's player5"

	self playerAt: 5 put: ( ( self combo5 selectedItem ) new: 5 ).
	( self playerAt: 5 ) initialize!
   
initializePlayers
	" Private - Initializes the receiver's players"

	players := Array new: 5.
	self initializePlayer1.
	self initializePlayer2.
	self initializePlayer3.
	self initializePlayer4.
	self initializePlayer5!
  
playerAt: anInteger
	" Return the player at position anInteger."

	^self players at: anInteger!
  
playerAt: anInteger put: aTeamPlayer
	" Put aTeamPlayer on players position anInteger."

	^self players at: anInteger put: aTeamPlayer!
  
players
    "Returns the instance var of the receiver
     for external manipulation"

	players isNil ifTrue: [ self initializePlayers ].
    ^players!

players: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    players := anObject!
 
running

	"Answer the value of running.
		(Generated by WindowBuilder Pro)"

	#generated.
	^running!
  
running: anObject

	"Set the value of running to <anObject>.
		(Generated by WindowBuilder Pro)"

	#generated.
	running := anObject!
  
status: aString
	" Send aString to the statusBar. "

	( self statusBar statusBoxAt: #notifier ) contents: aString!
   
statusBar

	^self paneNamed: 'statusBar'!
 
stopPlayer: anInteger
	"Stop player (1-5) position."
	| player |
	player := self playerAt: anInteger.
	player stop; commitWheels!
   
updatePlayer: anInteger
	"Update player (1-5) position."
	| player |
	player := self playerAt: anInteger.
	player
		update; 
		commit!

updatePlayers

	self updatePlayer: 1.
	self updatePlayer: 2.
	self updatePlayer: 3.
	self updatePlayer: 4.
	self updatePlayer: 5! !



!Field2DCompositePane class methods !
  
wbBasicVersion

	"Private - Answer the WindowBuilder Pro version.
		Generated in: Visual Smalltalk 3.1.1 Win32"

	^3.11! !



!Field2DCompositePane methods !
  
addSubpanes

	"WARNING!! This method was automatically generated by 
	WindowBuilder. Code you add here which does not conform to 
	the WindowBuilder API will probably be lost the next time 
	you save your layout definition."

	| graphPane xDU yDU |
	#generated.
	xDU := (SysFont width + 1 roundTo: 2) / 4.
	yDU := SysFont height / 8.
	
		"Temporary Variables"
	graphPane := GraphPane new.
	
	self
		framingBlock: 
			(LayoutFrame new
				leftRatio: 1/2; leftInset: -112 * xDU;
				topRatio: 1/2; topInset: -95 * yDU;
				rightRatio: 1/2; rightInset: -112 * xDU;
				bottomRatio: 1/2; bottomInset: -95 * yDU).
	
	graphPane
		owner: self;
		setName: 'graphPane';
		when: #clicked: send: #graphPaneClicked: to: self;
		when: #display send: #graphPaneDisplay: to: self with: graphPane;
		when: #doubleClicked send: #graphPaneDoubleClicked: to: self with: graphPane;
		when: #needsContents send: #graphPaneNeedsContents: to: self with: graphPane;
		removeHorizontalScrollbarStyle;
		removeVerticalScrollbarStyle;
		framingBlock: 
			(LayoutFrame new
				leftRatio: 0; leftInset: 4 * xDU;
				topRatio: 0; topInset: 4 * yDU;
				rightRatio: 1; rightInset: 5 * xDU;
				bottomRatio: 1; bottomInset: 7 * yDU);
		startGroup;
		noTabStop;
		font: SysFont.
	self addSubpane: graphPane!
 
drawBall: aBall
	"Draw aBall in the receiver's graphPane."

	| aPen aPoint |
	aPoint := self mapPointToPane: aBall.
	aPen := self graphPane pen.
	aPen
		foreColor: Color green;
		up;
		goto: aPoint;
		down;
		backColor: Color green;
		circleFilled: 4;
		up;
		backColor: Color black;
		yourself.


	

	
!
   
drawRobot: aRobot
	"Draw aRobot in the receiver's graphPane."

	self drawRobot: aRobot color: Color yellow
!

drawRobot: aRobot color: aColor
	"Draw aRobot in the receiver's graphPane."

	| aPen aPoint rotation |
	rotation := "aRobot rotation" 90.
	aPoint := self mapPointToPane: aRobot.
	aPen := self graphPane pen.
	aPen
		foreColor: aColor;
		up;
		goto: (aPoint x - 10) @ (aPoint y - 10);
		down;
		backColor: aColor;
		boxFilled: (aPoint x + 10) @ (aPoint y + 10);
		up;
		backColor: Color black;
		yourself.
!
  
flipPoint: aPoint
	"Flip Y value to switch between pane and cartesian coordinates."

	^aPoint x @ ( self graphPane height - aPoint y ) abs!
  
graphPane
	" Return the graphPane of the receiver."

	^self paneNamed: 'graphPane'!
  
graphPaneClicked: aPoint

	"Callback for the #clicked: event in graphPane [GraphPane].
		(Generated by WindowBuilder Pro)"

	"( self mapPoint: aPoint ) inspect"
	"( self graphPane width @  self graphPane height ) inspect"
	"self drawBall: 90.0 @ 77.0"!
 
graphPaneDisplay: aPane

	"Callback for the #display event in graphPane [GraphPane].
		(Generated by WindowBuilder Pro)"

	| teamRobots opponentRobots currentBall |
	self graphPane pen backColor: Color black.
	teamRobots := self state teamRobots.
	opponentRobots := self state opponentRobots.
	currentBall := self state currentBall.
	self drawBall: currentBall.
	1 to: 5 do: [ :index| 
							self drawRobot: (teamRobots at: index) color: Color blue.
							self drawRobot: (opponentRobots at: index) color: Color yellow ]
!
  
graphPaneDoubleClicked: aPane

	"Callback for the #doubleClicked event in graphPane [GraphPane].
		(Generated by WindowBuilder Pro)"


!
  
graphPaneNeedsContents: aPane

	"Callback for the #needsContents event in graphPane [GraphPane].
		(Generated by WindowBuilder Pro)"

		"aPane
			backColor: Color black;
			invalidate;
			yourself"
!

initializeState
	" Private - Initializes the receiver's state"

	state := SmallsotDLL current environment!
   
mapPointToField: aPoint
	"Acomodate aPoint to match the field."

	| flippedPoint |
	flippedPoint := self flipPoint: aPoint.
	^ ( flippedPoint x // 4 )  @ ( flippedPoint  y // 4 ) !
   
mapPointToPane: aPoint
	"Acomodate aPoint to match the pane."

	| acPoint |
	acPoint := ( aPoint x * 4 ) rounded @ ( aPoint  y * 4 ) rounded.
	^ self flipPoint: acPoint!
  
state
    "Returns the instance var of the receiver
     for external manipulation"

	state isNil ifTrue: [ self initializeState ].
    ^state!

state: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    state := anObject!
 
updateWith: aSmallsotState
	"Update the receiver's graph pane drawings with aSmallsotState."

	self state: aSmallsotState.
	self graphPane invalidate

	! !



!SSBall class methods !

sizeInBytes
	"Private - answer the size in bytes of the RobotSoccer Vector3D struct.
	Each double is 8 bytes in size in VC++ 6."
    ^24
! !



!SSBall methods !
   
pos
	"Return the struct position which is a Vector3D struct."

	^SSVector3D fromBytes: ( self bytesAtOffset: 0 count: SSVector3D sizeInBytes )! !



!SSBounds class methods !
   
sizeInBytes
	"Private - answer the size in bytes of the RobotSoccer Vector3D struct.
	Each long is 4 bytes in size in VC++ 6."
    ^16! !



!SSBounds methods !
 
bottom
	"Return the RobotSoccer struct Bounds bottom value."

	^self longAtOffset: 12!
   
left
	"Return the RobotSoccer struct Bounds left value."

	^self longAtOffset: 0!

right
	"Return the RobotSoccer struct Bounds right value."

	^self longAtOffset: 4!
  
top
	"Return the RobotSoccer struct Bounds top value."

	^self longAtOffset: 8! !



!SSEnvironment class methods !
  
homeArraySize

	^5!
   
opponentArraySize

	^5!
   
sizeInBytes
	"Private - answer the size in bytes of the RobotSoccer Vector3D struct.
	Each double is 8 bytes in size in VC++ 6."
    ^520! !



!SSEnvironment methods !
 
currentBall
	"Return struct current ball field as a SSBall."
	| prevBytes |
	prevBytes := SSRobot sizeInBytes * self class homeArraySize.
	^SSBall fromBytes: ( self bytesAtOffset: prevBytes count: SSBall sizeInBytes )!
  
display
	"A string for display."
	| prevBytes |
	prevBytes := 
		( SSRobot sizeInBytes * self class homeArraySize ) + 
		( SSBall sizeInBytes * 3 ) + 
		( SSBounds sizeInBytes * 2 ) + 
		4 + 
		4 +
		( SSOpponentRobot sizeInBytes * self class opponentArraySize ) +
		4 "?"!
 
fieldBounds
	"Return struct field bounds field as a SSBounds."
	| prevBytes |
	prevBytes := ( SSRobot sizeInBytes * self class homeArraySize ) + ( SSBall sizeInBytes * 3 ).
	^SSBounds fromBytes: ( self bytesAtOffset:  prevBytes count: SSBounds sizeInBytes )!
  
gameState
	"Return struct gameState as an Integer."
	| prevBytes |
	prevBytes := ( SSRobot sizeInBytes * self class homeArraySize ) + ( SSBall sizeInBytes * 3 ) + ( SSBounds sizeInBytes * 2).
	^self longAtOffset: prevBytes!
 
goalBounds
	"Return struct goal bounds field as a SSBounds."
	| prevBytes |
	prevBytes := ( SSRobot sizeInBytes * self class homeArraySize ) + ( SSBall sizeInBytes * 3 ) + SSBounds sizeInBytes.
	^SSBounds fromBytes: ( self bytesAtOffset:  prevBytes count: SSBounds sizeInBytes )!
 
home: anInteger
	"Answer element in the receiver's home array at anInteger position (1 relative)."

	( (anInteger > self class homeArraySize) or: [ anInteger <= 0 ] ) 
		ifTrue: [ ^self error: 'Index out of bounds.' ].

	^SSRobot fromBytes: ( self bytesAtOffset:  ((anInteger - 1) * SSRobot sizeInBytes ) count: SSRobot sizeInBytes )!

lastBall
	"Return struct last ball field as a SSBall."
	| prevBytes |
	prevBytes := ( SSRobot sizeInBytes * self class homeArraySize ) + ( SSBall sizeInBytes ).
	^SSBall fromBytes: ( self bytesAtOffset: prevBytes count: SSBall sizeInBytes )!
   
opponent: anInteger
	"Answer element in the receiver's opponent array at anInteger position (1 relative)."
	| prevBytes |
	( (anInteger > self class opponentArraySize) or: [ anInteger <= 0 ] ) 
		ifTrue: [ ^self error: 'Index out of bounds.' ].
	prevBytes := ( SSRobot sizeInBytes * self class homeArraySize ) + ( SSBall sizeInBytes * 3 ) + ( SSBounds sizeInBytes * 2 ) + 4 + 4.
	"^SSOpponentRobot fromAddress: ( self addressAtOffset: (prevBytes + ((anInteger - 1) * SSOpponentRobot sizeInBytes )))"
	^SSOpponentRobot fromBytes: ( self bytesAtOffset:  (prevBytes + ((anInteger - 1) * SSOpponentRobot sizeInBytes )) count: SSOpponentRobot sizeInBytes )!
 
predictedBall
	"Return struct last ball field as a SSBall."
	| prevBytes |
	prevBytes := ( SSRobot sizeInBytes * self class homeArraySize ) + ( SSBall sizeInBytes * 2 ).
	^SSBall fromBytes: ( self bytesAtOffset: prevBytes count: SSBall sizeInBytes )!
  
userData
	"User data pointer, could be anything."
	| prevBytes |
	prevBytes := 
		( SSRobot sizeInBytes * self class homeArraySize ) + 
		( SSBall sizeInBytes * 3 ) + 
		( SSBounds sizeInBytes * 2 ) + 
		4 + 
		4 +
		( SSOpponentRobot sizeInBytes * self class opponentArraySize ).!
  
whosBall
	"Return struct whosBall as an Integer."
	| prevBytes |
	prevBytes := ( SSRobot sizeInBytes * 5 ) + ( SSBall sizeInBytes * 3 ) + ( SSBounds sizeInBytes * 2) + 4.
	^self longAtOffset: prevBytes! !



!SSOpponentRobot class methods !

sizeInBytes
	"Private - answer the size in bytes of the RobotSoccer Vector3D struct.
	Each double is 8 bytes in size in VC++ 6."
    ^32! !



!SSOpponentRobot methods !

pos
	"Return the struct position which is a Vector3D struct."

	^SSVector3D fromBytes: ( self bytesAtOffset: 0 count: SSVector3D sizeInBytes )!
  
rotation
		"Return the struct rotation as a Float value."
		^self floatAtOffset: 24! !



!SSRobot class methods !

sizeInBytes
	"Private - answer the size in bytes of the RobotSoccer Vector3D struct.
	Each double is 8 bytes in size in VC++ 6."
    ^48
! !



!SSRobot methods !
  
velocityLeft
		"Return the struct velocityLeft as a Float value."
		^self floatAtOffset: 32!
  
velocityRight
		"Return the struct velocityRight as a Float value."
		^self floatAtOffset: 40! !



!SSVector3D class methods !
   
sizeInBytes
	"Private - answer the size in bytes of the RobotSoccer Vector3D struct.
	Each double is 8 bytes in size in VC++ 6."
    ^24
! !



!SSVector3D methods !
   
x
	"Return struct x field as a Float value."

	^self floatAtOffset: 0!
   
y
	"Return struct y field as a Float value."

	^self floatAtOffset: 8!
   
z
	"Return struct z field as a Float value."

	^self floatAtOffset: 16! !
