  
"
    __________________________________________________
    @Alejandro F. Reimondo 14/07/00
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

Object variableSubclass: #WindowBuilderAndSubPanesLoader
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !


!WindowBuilderAndSubPanesLoader class methods !
  
loadNow
	"Load the libraries NOW.
	WindowBuilderAndSubPanesLoader loadNow.
	"

	self new
		loadWindowBuilder;
		loadSubPanes;
		yourself.! !



!WindowBuilderAndSubPanesLoader methods !
   
checkBound: aLibraryName
	" Private - Check library bindings if not loader yet, load the library named aLibraryName. "

    (SmalltalkLibraryBinder isBound: aLibraryName)
    ifFalse: [ SmalltalkLibraryBinder bindTo: aLibraryName ].!
   
loadAll: libraryNames
	" Private - Load the libraries libraryNames. "

	libraryNames do: [:each | self checkBound: each ].!
  
loadSubPanes
	"Load the SubPanes libraries."

	self
		preLoadSubPanes;
		loadSubPanesRunTime;
		loadSubPanesDevelopment;
		postLoadSubPanes;
		yourself.!
   
loadSubPanesDevelopment
	" Private - Load the SubPanes development support."

	Smalltalk isRunTime ifTrue: [ ^self ].
	self loadAll: #( 'SP31DEVW' ).!
  
loadSubPanesRunTime
	" Private - Load the SubPanes runtime support."

	self loadAll: #(
		'WB31RBW'   "WindowBuilder Pro Runtime"
		'WB31REFW'   "EnhancedEntryField Runtime"
		'SP31RBW'   "Base Runtime"
		'SP31RBBW'   "Bitmap Button Runtime"
		'SP31RFW'   "Input Field Runtime"
		'SP31RMW'   "Miscellaneous Runtime"
		'SP31RCLW'   "ColumnarListBox Runtime"
		'SP31RHLW'   "HierarchicalListBox Runtime"
		'SP31RTW'   "Table Runtime"
		'WB31RPMW'   "WindowBuilder Pro Runtime Pool Manager"
		)!
  
loadWindowBuilder
	"Load the WindowBuilder libraries."

	self
		preLoadWindowBuilder;
		loadWindowBuilderRunTime;
		loadWindowBuilderDevelopment;
		postLoadWindowBuilder;
		yourself.!
 
loadWindowBuilderDevelopment
	" Private - Load the WindowBuilder development support."

	Smalltalk isRunTime ifTrue: [ ^self ].

	self preLoadWindowBuilderDevelopment.
	self loadAll: #(
        'VIML31W'   "Visual Smalltalk Image List"
		'VBLB31W'   "Visual Smalltalk Button List Box Control"
		'VPROM31'   "Visual Smalltalk Property Manager"
		'VSTP31W'   "Visual Smalltalk Status Pane"
		'VSPN31W'   "Visual Smalltalk Spin Button Control"
		'VTLP31W'   "Visual Smalltalk Tool Pane"
		'VHDT31W'   "Visual Smalltalk Header Tester"
		'VSTW31W'   "Visual Smalltalk Status Window Control"
		'VCCC31W'   "Visual Smalltalk Win32 Common Control Constants"
		'WB31DEVW'   "WindowBuilder Pro Development"
		'WB31DPSW'   "WindowBuilder Pro Development Shared"
		'WB31DTRW'   "WindowBuilder Pro Translator Utility"
		'VLSV31W'   "Visual Smalltalk List View"
		'VRED31W'   "Visual Smalltalk Rich Edit Control"
		'VTLB31W'   "Visual Smalltalk Toolbar Control"
		'VTRV31W'   "Visual Smalltalk Tree View"
		'VTRK31W'   "Visual Smalltalk Track Bar Control"
		'WB31D95W'   "WindowBuilder Pro Development Win95"
		).!
   
loadWindowBuilderRunTime
	" Private - Load the WindowBuilder runtime support."

	self loadAll: #(
		'WB31RBW' "WindowBuilder Pro 3.1 Runtime Base for Win32"
" 'WB31RBMW' " "WindowBuilder Pro 3.1 Runtime Bitmap Manager"
		'WB31REFW' "WindowBuilder Pro 3.1 Runtime EnhancedEntryField"
		'WB31RMW' "WindowBuilder Pro 3.1 Runtime Miscellaneous"
		'WB31RCPW' "WindowBuilder Pro 3.1 Runtime CompositePane"
		'WB31RTBW' "WindowBuilder Pro 3.1 Runtime ToolBar"
		'WB31RFXW' "WindowBuilder Pro 3.1 Runtime Base Image Fixes"
		'WB31ROPW' "WindowBuilder Pro 3.1 Runtime Base Image Optimizations"
		'WB31RPMW' "WindowBuilder Pro 3.1 Runtime Pool Manager"

		'WB31R20W'    "WindowBuilder Pro 2.0 Runtime Support (FramingParameters)"
" 'WB31RALW' "	"WindowBuilder Pro 3.1 Runtime Obsolete for Win32"
		'WB31ROBW'    "WindowBuilder Pro 3.1 Runtime Obsolete for Win32"
" 'WB31RSTW' "	"WindowBuilder Pro 3.1 Runtime StatusPane Support for Win32"
" 'WB31MDI' "	"WindowBuilder Pro 3.1 Runtime MDI Support for Win32"
" 'WB31R95W' "	"WindowBuilder Pro 3.1 Runtime Windows 95 Support for Win32"
		).!
  
postLoadSubPanes
	" Private - Post-Load the SubPanes libraries."

	"do nothing here."!
   
postLoadWindowBuilder
	" Private - Post-Load the WindowBuilder libraries."

	"We will not want to open dialogs."
	self removeDeferredMessageSending: #aboutWB.!
 
preLoadSubPanes
	" Private - Pre-Load the SubPanes libraries."

	"do nothing here."!
 
preLoadWindowBuilder
	" Private - Pre-Load the WindowBuilder libraries.
	We will check the integrity of OS Constants pool."

	(Smalltalk includesKey: #OperatingSystemConstants)
	ifFalse: [
		Smalltalk
			at: #OperatingSystemConstants put: Dictionary new;
			yourself
	].
	(Smalltalk includesKey: #WinLong)
	ifFalse: [
		Smalltalk
			at: #WinLong put: ExternalLong;
			yourself
	].!

preLoadWindowBuilderDevelopment
	" Private - Pre-Load the WindowBuilder libraries."

	Smalltalk at: #PWindowBuilder ifAbsentPut: [ nil ].
	self loadAll: #(
		'WB31RFXW'   "Base Image Fixes"
		'WB31RBW'   "WindowBuilder Pro Runtime"
		'WB31REFW'   "EnhancedEntryField Runtime"
		'WB31RMW'   "Miscellaneous Runtime"
		'WB31RCPW'   "CompositePane Runtime"
		'WB31RTBW'   "ToolBar Runtime"
		'WB31RPMW'   "Pool Manager"
		'VSTP31W'   "Visual Smalltalk Status Pane"
		'WB31RSTW'   "StatusPane and StatusBox Runtime"
		'VHDR31W'   "Visual Smalltalk Header Control"
		'VSPN31W'   "Visual Smalltalk Spin Button Control"
		'VTAB31W'   "Visual Smalltalk Tab Control"
		'WB31R95W'   "Win95 Runtime Fixes"
		'WB31R20W'   "WindowBuilder Pro v2.0 Runtime Obsolete"
		'WB31ROBW'   "WindowBuilder Pro v1.0 Runtime Obsolete"
	).

	self wbBuildStubParts.!
 
removeDeferredMessageSending: aSelector
	" Private - Remove a deferred message sending aSelector. "

	| message |
	message := DeferredRequests detect: [:one|
		one isMessage and: [ one selector == aSelector ]
		] ifNone: [].
	message notNil ifTrue: [
	    [ DeferredRequests remove: message ] evaluateWithoutInterrupts
	].!

wbBuildStubParts
	" Private - Build Stubs for Parts if needed. "

Smalltalk at: #PARTSApplicationHolder ifAbsent: [
    Object subclass: #PARTSApplicationHolder
      instanceVariableNames:  ' application eventTable '
      classVariableNames: ' RecyclingBin '  poolDictionaries: '' ].

Smalltalk at: #PARTSCheckBoxPart ifAbsent: [
    (Smalltalk at: #CheckBox) subclass: #PARTSCheckBoxPart
      instanceVariableNames: '' classVariableNames:  ' SupportsLabelLeftOfButton ' poolDictionaries: '' ].

Smalltalk at: #PARTSCodeGeneratorInterface ifAbsent: [
    Object subclass: #PARTSCodeGeneratorInterface
      instanceVariableNames: ' inputDirectoryName outputDirectoryName logStream fileDescriptor interactive '
      classVariableNames: '' poolDictionaries: ''   ].

Smalltalk at: #PARTSEntryFieldPart ifAbsent: [
    (Smalltalk at: #EntryField) subclass: #PARTSEntryFieldPart
      instanceVariableNames: ' emptyValue '
      classVariableNames: ' AlignmentLabels AlignmentValues ConvertCharactersLabels ConvertCharactersValues '
      poolDictionaries: ''  ].

Smalltalk at: #PARTSFormattedEntryField ifAbsent: [
    (Smalltalk at: #PARTSEntryFieldPart) subclass: #PARTSFormattedEntryField
      instanceVariableNames: ' datum '      classVariableNames: '' poolDictionaries: ''  ].

Smalltalk at: #PARTSNumericField ifAbsent: [
    (Smalltalk at: #PARTSFormattedEntryField) subclass: #PARTSNumericField
      instanceVariableNames: ''      classVariableNames: ''      poolDictionaries: ''  ].

Smalltalk at: #PARTSFixedDecimalEntryFieldPart ifAbsent: [
    (Smalltalk at: #PARTSNumericField) subclass: #PARTSFixedDecimalEntryFieldPart
      instanceVariableNames:  ' signed decimalPlace digits '  classVariableNames: ''  poolDictionaries: '' ].

Smalltalk at: #PARTSCurrencyEntryFieldPart ifAbsent: [
    (Smalltalk at: #PARTSFixedDecimalEntryFieldPart) subclass: #PARTSCurrencyEntryFieldPart
      instanceVariableNames: ''      classVariableNames: ''      poolDictionaries: '' ].

Smalltalk at: #PARTSExpressionEntryField ifAbsent: [
    (Smalltalk at: #EntryField) subclass: #PARTSExpressionEntryField
      instanceVariableNames: ''      classVariableNames: ''      poolDictionaries: ''    ].

Smalltalk at: #PARTSFloatEntryFieldPart ifAbsent: [
    (Smalltalk at: #PARTSNumericField) subclass: #PARTSFloatEntryFieldPart
      instanceVariableNames: ''      classVariableNames: ''      poolDictionaries: ''  ].

Smalltalk at: #PARTSIntegerEntryFieldPart ifAbsent: [
    (Smalltalk at: #PARTSNumericField) subclass: #PARTSIntegerEntryFieldPart
      instanceVariableNames: ''      classVariableNames: ''      poolDictionaries: ''    ].

Smalltalk at: #PARTSListPanePart ifAbsent: [
    ListBox subclass: #PARTSListPanePart
      instanceVariableNames: ''      classVariableNames:   ' SupportsShowDisabledScrollbar '      poolDictionaries: ''    ].

Smalltalk at: #PARTSPhoneNumberEntryFieldPart ifAbsent: [
    (Smalltalk at: #PARTSFormattedEntryField) subclass: #PARTSPhoneNumberEntryFieldPart
      instanceVariableNames: ''      classVariableNames: ''      poolDictionaries: '' ].

Smalltalk at: #PARTSDialog ifAbsent: [
    WindowDialog subclass: #PARTSDialog
      instanceVariableNames: ''      classVariableNames: ''      poolDictionaries: ''    ].

Smalltalk at: #PARTSTabOrderEditor ifAbsent: [
    (Smalltalk at: #PARTSDialog) subclass: #PARTSTabOrderEditor
      instanceVariableNames:         ' orderedChildren tabStops groupLeaders children answer '
      classVariableNames: ''      poolDictionaries: ''    ].

! !


! IdentityDictionary methods !
keysAsArray
        "Answer a collection containing all the keys
         in the receiver."

    | answer |
    answer := OrderedCollection new: self size.
    1 to: contents size by: 2 do: [ :index |
        (contents at: index) == nil
            ifFalse: [answer add: (contents at: index)]].
    ^answer! !

! Dictionary methods !
keysAsArray
        "Answer a collection containing all the keys
         in the receiver."

    | answer |
    answer := OrderedCollection new: self size.
    self associationsDo: [ :assoc |
        answer add: assoc key].
    ^answer! !